import es, os.path, popuplib, cPickle, cfglib, time, spe, cmdlib, menulib, random, gamethread, playerlib, weaponlib

'''
Todo:
    XP system
    Prestiges
    Class Design
    Better API for classes
    Events
        Will probably do events in seperate scripts to make modifing them easier
'''

info = es.AddonInfo() 
info.name = "D&D 3.5" 
info.version = "Alpha (0.1.4.6)" 
info.author = "Devin Pariseau" 
info.url = "http://addons.eventscripts.com/addons/view/dnd35" 
info.description = "Level Up and gain abilities! Select race/class combo" 
es.ServerVar('dnd',info.version,'D&D 3.5 By: %s'%info.author).makepublic()

config = cfglib.AddonCFG(es.getAddonPath("dnd") + "/xp.cfg")

config.text("******************************")
config.text("  D&D SETTINGS")
config.text("*****************************")
config.text("Be careful when setting the names of commands so that they do not interfere")
config.text("with other scripts you are running")
config.text("******************************")

killxp =        config.cvar("dndkillxp",        50,             "Amount of XP for getting a kill")
headshotxp =    config.cvar("dndheadshotxp",    50,             "Amount of XP for getting a headshot")
knifexp =       config.cvar("knifexp",          50,             "Amount of XP for a knife kill")
bombplantxp =   config.cvar("bombplantxp",      60,             "Amount of XP for planting the bomb")
grenadexp =     config.cvar("grenadexp",        40,             "Amount of XP for a grenade kill")
bombxp =        config.cvar("bombxp",           100,            "Amount of XP for defusing the bomb") 
bombexxp =      config.cvar("bombexxp",         150,            "Amount of XP for the bomb exploding")
hostagexp =     config.cvar("hostagexp",        35,             "Amount of XP for rescuing a hostage")
allhostagexp =  config.cvar("allhostagexp",     70,             "Amount of XP for rescuing all hostages")
teamkillxp =    config.cvar("teamkillxp",       300,            "Amount of XP lost for killing a team mate")
zombiexp =      config.cvar("zombiexp",         95,             "Amount of XP for getting a kill while a Zombie")
killspreexp =   config.cvar("killspreexp",      10,             "Amount of XP for getting an additional kill beyond 5 without dieing")
highxp =        config.cvar("highxp",           25,             "Amount of XP for each level higher an opponent is")
roundxp =       config.cvar("roundxp",          35,             "Amount of XP for winning the round")
roundalivexp =  config.cvar("roundalivexp",     1,              "Whether or not a player must be alive for Round Won XP. 1 = Yes 0 = No")
bountyxp =      config.cvar("bountyxp",         10,             "Amount of XP bonus for killing someone with over 4 kills. Increase for every kill they get")

config.write()

es.ServerVar('dnd_debug', 1)

def dndDebug(msg):
    if int(es.ServerVar('dnd_debug')):
        es.msg('#multi', '#default', '[D&D Debug]', '#green', msg)

def dndMsg(msg):
    es.msg('#multi', '#green', '[D&D]', '#default', msg)
    
def dndTell(userid, msg=[]):
    es.tell(userid, '#multi', '#green', '[D&D]', '#default', msg)
    
menu_commands = ['rpgmenu', 'wcmenu', 'wcsmenu', 'menu', 'dndmenu']

def unload():
    gamethread.cancelDelayed('dndtick')
    for userid in es.getUseridList():
        es.server.queuecmd("kickid %s 'Reloading DND mod - please reconnect'"%userid)
    saveDatabase()
    commandsToUnregister = ['!playerinfo', 'playerinfo']
    
    for command in menu_commands:
        commandsToUnregister.append(command)
        
    for command in commandsToUnregister:
        cmdlib.unregisterSayCommand(command)
        cmdlib.unregisterClientCommand(command)
        newCommand = '!' + command
        cmdlib.unregisterSayCommand(newCommand)
        cmdlib.unregisterClientCommand(newCommand)
        
    for command in ['skills', 'skill', 'ability', 'abilities']:
        cmdlib.unregisterSayCommand(command)
        cmdlib.unregisterClientCommand(command)
        newCommand = '!' + command
        cmdlib.unregisterSayCommand(newCommand)
        cmdlib.unregisterClientCommand(newCommand)
        
    es.unload('dnd/subscripts/player_activate')
    es.unload('dnd/subscripts/round_start')
    es.unload('dnd/subscripts/player_spawn')
    es.unload('dnd/subscripts/player_hurt')
    es.unload('dnd/subscripts/player_death')
    es.unload('dnd/subscripts/round_end')
    es.unload('dnd/subscripts/bomb_events')
    es.unload('dnd/subscripts/hostage_events')
    es.unload('dnd/subscripts/menu')
    es.unload('dnd/subscripts/spells')
    es.unload('dnd/subscripts/adverts')
    
def load():
    config.execute()
    try:
        loadDatabase()
    except:
        dndMsg('Failed to load database')
        
    global main_menu, class_menu, race_menu, normal_races, la_races, mainSelect, normalRaceSelect, temp_database
    temp_database = {}
        
    commandsToUnregister = ['!playerinfo', 'playerinfo']
    
    for command in menu_commands:
        commandsToUnregister.append(command)
        
    for command in commandsToUnregister:
        cmdlib.unregisterSayCommand(command)
        cmdlib.unregisterClientCommand(command)
        newCommand = '!' + command
        cmdlib.unregisterSayCommand(newCommand)
        cmdlib.unregisterClientCommand(newCommand)    
        
    for command in menu_commands:
        cmdlib.registerSayCommand(command, menuSend, 'Sends a menu to the player')
        cmdlib.registerClientCommand(command, menuSend, 'Sends a menu to the player')
        newCommand = '!' + command
        cmdlib.registerSayCommand(newCommand, menuSend, 'Sends a menu to the player')
        cmdlib.registerClientCommand(newCommand, menuSend, 'Sends a menu to the player')
        
    for command in ['playerinfo']:
        cmdlib.registerSayCommand(command, playerInfo, 'Sends an info menu to the player')
        cmdlib.registerClientCommand(command, playerInfo, 'Sends an info menu to the player')
        newCommand = '!' + command
        cmdlib.registerSayCommand(newCommand, playerInfo, 'Sends an info menu to the player')
        cmdlib.registerClientCommand(newCommand, playerInfo, 'Sends an info menu to the player')
        
    for command in ['skills', 'skill', 'ability', 'abilities']:
        cmdlib.registerSayCommand(command, skillSend, 'Sends an info menu to the player')
        cmdlib.registerClientCommand(command, skillSend, 'Sends an info menu to the player')
        newCommand = '!' + command
        cmdlib.registerSayCommand(newCommand, skillSend, 'Sends an info menu to the player')
        cmdlib.registerClientCommand(newCommand,skillSend, 'Sends an info menu to the player')

    
    main_menu = popuplib.create('main_menu')
    main_menu.addline('Dungeons and Dragons CSS Main Menu:')
    main_menu.addline('-> 1. Race')
    main_menu.addline('-> 2. Class')
    main_menu.addline('-> 3. Prestige') # No prestiges at the moment
    main_menu.addline('-> 4. Info Menu') 
    main_menu.addline('-> 5. Class Weapon List') # Not defined yet
    main_menu.addline('-> 6. Stats')
    main_menu.addline('-> 7. Player Menu')
    main_menu.addline('-> 0. Exit')
    main_menu.submenu(1, 'race_menu')
    main_menu.submenu(2, 'class_menu')
    main_menu.submenu(4, 'info_menu')
    main_menu.menuselect = mainSelect
    
    info_menu = popuplib.create('info_menu')
    info_menu.addline('Please choose something to see information about: (Info Menu Not Complete)')
    info_menu.addline('-> 1. Races')
    info_menu.addline('-> 2. Classes')
    info_menu.addline('-> 9. Back')
    info_menu.addline('-> 0. Exit')
    info_menu.submenu(1, 'raceInfoMenu')
    info_menu.submenu(2, 'classInfo')
    info_menu.submenu(9, 'main_menu')
    
    raceInfoMenu = popuplib.create('raceInfoMenu')
    raceInfoMenu.addline('Please choose something to see information about: (Info Menu Not Complete)')
    raceInfoMenu.addline('-> 1. Normal Races')
    raceInfoMenu.addline('-> 2. Level-Adjustment Races (None added yet)')
    raceInfoMenu.addline('-> 9. Back')
    raceInfoMenu.submenu(1, 'normalRacesInfo')
    raceInfoMenu.submenu(9, 'info_menu')
    #raceInfoMenu.submenu(2, 'laRacesInfo')
    raceInfoMenu.addline('-> 0. Exit')

    race_menu = popuplib.create('race_menu')
    race_menu.addline('Please choose what type of race you wish to be:')
    race_menu.addline('-> 1. Normal Races')
    race_menu.addline('-> 2. Level Adjustment Races')
    race_menu.addline('-> 9. Back')
    race_menu.addline('0. Exit')
    race_menu.submenu(1, 'normal_races')
    race_menu.submenu(2, 'la_races')
    race_menu.submenu(9, 'main_menu')
    
    la_races = popuplib.create('la_races')
    la_races.addline('Dungeons and Dragons CSS Level-Adjustment Races:')
    la_races.addline('-> 9. Back')
    la_races.addline('0. Exit')
    la_races.submenu(9, 'race_menu')
    la_races.menuselect = laRaceSelect
    
    es.reload('dnd/subscripts/player_activate')
    es.reload('dnd/subscripts/round_start')
    es.reload('dnd/subscripts/player_spawn')
    es.reload('dnd/subscripts/player_hurt')
    es.reload('dnd/subscripts/player_death')
    es.reload('dnd/subscripts/round_end')
    es.reload('dnd/subscripts/bomb_events')
    es.reload('dnd/subscripts/hostage_events')
    es.reload('dnd/subscripts/menu')
    es.reload('dnd/subscripts/spells')
    es.reload('dnd/subscripts/adverts')
        
def classSelect(userid, choice, popupid):
    newClass = choice
    Player(userid).changeClass(newClass)
    
def normalRaceSelect(userid, choice, popupid):
    Player(userid).changeRace(choice)

def loadDatabase():
    global player_database
    str_path = es.getAddonPath('dnd') + '/player_database.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        player_database = cPickle.load(file_users)
        file_users.close()
        #listDatabase()
        dndMsg('Levels loaded')
        
def saveDatabase():
    global player_database
    str_path = open(es.getAddonPath('dnd') + '/player_database.db', 'w')
    cPickle.dump(player_database, str_path)
    #listDatabase()
    str_path.close()
    dndMsg('Levels saved')
    
def playerSelection(userid, choice, popupid):
    statPlayer = Player(choice)
    statmenu = popuplib.create('statmenu_%s'%userid)
    statmenu.addline('Player Stats: %s'%es.getplayername(choice))
    statmenu.addline('  %s %s %s'%(statPlayer.getRace(), statPlayer.getLevel(), statPlayer.getClass()))
    statmenu.addline('  %s xp/%s xp'%(statPlayer.getXp(), statPlayer.getLevel() * 1000))
    statmenu.addline('-> 9. Main Menu')
    statmenu.submenu(9, 'main_menu')
    statmenu.send(userid)
    popuplib.delete('statmenu_%s'%userid)
                                    
def mainSelect(userid, choice, popupid):
    if choice == 3:
        dndTell(userid, 'Currently there are no prestige classes - Please be patient')
    if choice in [5]:
        dndTell(userid, 'Currently adding class mechanics - Please be patient')
    if choice == 6:
        statPlayer = Player(userid)
        statmenu = popuplib.create('statmenu_%s'%userid)
        statmenu.addline('Player Stats: %s'%es.getplayername(userid))
        statmenu.addline('  %s %s %s'%(statPlayer.getRace(), statPlayer.getLevel(), statPlayer.getClass()))
        statmenu.addline('  %s xp/%s xp'%(statPlayer.getXp(), statPlayer.getLevel() * 1000))
        if statPlayer.getLevelAdjustment() > 0:
            statmenu.addline('  Level Adjustment: %s'%statPlayer.getLevelAdjustment())
        statmenu.send(userid)
        popuplib.delete('statmenu_%s'%userid)
    if choice == 7:
        es.cexec(userid, '!playerinfo')
                
def laRaceSelect(userid, choice, popupid):
    pass 
    
def menuSend(userid, args):
    x = int(popuplib.active(userid)['count'])
    if x:
        dndTell(userid, 'Please close your other open menus')
    else:
       main_menu.send(userid)
       
def skillSend(userid, args):
    x = int(popuplib.active(userid)['count'])
    if x:
        dndTell(userid, 'Please close your other open menus')
    else:
        popuplib.send('%s Info'%Player(userid).getClass(), userid)
    
def playerInfo(userid, args):
    playerMenu = popuplib.easymenu('player_menu_%s'%userid, '_popup_choice', playerSelection)
    playerMenu.settitle('Player Stat Selection')
    for player in es.getUseridList():
        playerMenu.addoption(player, es.getplayername(player))
    playerMenu.send(userid)
    popuplib.delete('player_menu_%s'%userid)
    
class Player:
    global player_database
    def __init__(self, player):
        self.userid = player
        self.Player = es.getplayersteamid(player)
        self.Name   = es.getplayername(player)
        if self.Player == 'BOT':
            self.Player = self.Player + '_' + self.Name
        self.Team   = es.getplayerteam(player)
        if self.Player not in player_database:
            player_database[self.Player] = {
                                        'name'      :self.Name,
                                        'last connected':time.time(),
                                        'class'     :'Fighter',
                                        'race'      :'Human',
                                        'la'        :0,
                                        'prestige'  :0,
                                        'Fighter'   : 
                                                        {
                                                            'level' :1,
                                                            'xp'    :0
                                                        }
                                    }
            dndTell(self.userid, 'Your class and race have been automatically reset to Human Fighter')
            dndMsg('%s is new! Give them some help!'%self.Name)
        else:
            pass
            # Need to get players last connection
            #dndTell(player, 'Last Connected: %s'%time.ctime())
            
        if 'kills' not in player_database[self.Player]:
            player_database[self.Player]['kills'] = 0
        
        player_database[self.Player]['last connected'] = time.time()
        
    def addKills(self, kills=1):
        player_database[self.Player]['kills'] += kills
        
    def setKills(self, amount):
        player_database[self.Player]['kills'] = amount
        
    def getKills(self):
        return player_database[self.Player]['kills']
        
    def alive(self):
        if es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'):
            return 0
        return 1
        
    def changeRace(self, newRace):
        if self.alive():
            dndTell(self.userid, 'You must be dead to change your race')
        else:
            player_database[self.Player]['race'] = newRace
            dndTell(self.userid, 'You are now a %s'%newRace)
            
    def changeClass(self, newClass):
        if self.alive():
            dndTell(self.userid, 'You must be dead to change your class')
        else:
            player_database[self.Player]['class'] = newClass
            if newClass not in player_database[self.Player]:
                player_database[self.Player][newClass]={
                                                            'level' :1,
                                                            'xp'    :0
                                                        }
            dndTell(self.userid, 'You are now a %s'%newClass)
    
    def getRace(self):
        return player_database[self.Player]['race']
    
    def getClass(self):
        return player_database[self.Player]['class']
        
    def getLevel(self, classLevel=None):
        if not classLevel:
            return player_database[self.Player][self.getClass()]['level']
        else:
            return player_database[self.Player][classLevel]['level']
                
    def getLevelAdjustment(self):
        return player_database[self.Player]['la']
        
    def getXp(self):
        return player_database[self.Player][self.getClass()]['xp']
        
    def giveLevel(self, levels):
        es.emitsound('player', self.userid, 'ambient/energy/whiteflash.wav', '0.7', '0.5')
        player_database[self.Player][self.getClass()]['level'] += levels
        dndMsg('Congratulations, %s, for leveling up! He is now Level %s!'%(self.Name, self.getLevel()))
        
    def giveXp(self, amount, reason=None):
        count = 0
        for userid in es.getUseridList():
            if es.getplayerteam(userid) > 1:
                count += 1
        if count > 1:
            player_database[self.Player][self.getClass()]['xp'] += amount
            if reason:
                dndTell(self.userid, 'You have gained %s xp %s'%(amount, reason))
            else:
                dndTell(self.userid, 'You have gained %s xp'%amount)
            if self.getXp() / self.getLevel() >= 1000:
                player_database[self.Player][self.getClass()]['xp'] -= self.getLevel() * 1000
                self.giveLevel(1)
            

            
class Temp:
    '''
    Class used to get and set temporary information
    Would like to reset it round to round
    Need to have some sort of API wrapper for this in another file to create a standard
    '''
    def __init__(self, player):
        self.Player = int(player)
        self.Name   = es.getplayername(player)
        self.Team   = es.getplayerteam(player)
        if self.Player not in temp_database:
            temp_database[self.Player] = {}
            
    def get(self, item):
        if item in temp_database[self.Player]:
            return temp_database[self.Player][item]
        else:
            temp_database[self.Player][item] = 0
            return 0
            
    def set(self, item, value=[]):
        if not value:
            temp_database[self.Player][item] = 0
        else:
            temp_database[self.Player][item] = value
            
    def add(self, item, value):
        
        self.get(item)
        temp_database[self.Player][item] += value
        
def round_end(ev):
    gamethread.cancelDelayed('dndtick')
        
def stun(userid, duration=None):
    '''Used to stop a player from walking (can still shoot ect.)'''
    es.setplayerprop(userid, "CBaseEntity.movetype", 0)
    if duration:
        Temp(userid).add('stun', duration)
        unstun(userid)
        
def unstun(userid):
    if not Temp(userid).get('stun'):
        es.setplayerprop(userid, "CBaseEntity.movetype", 2)
    else:
        Temp(userid).add('stun', -1)
    gamethread.delayedname(1, 'dndtick', unstun, userid)
    
def freeze(userid, duration=None):
    '''Used to stop a player from walking (can still shoot ect.)'''
    es.setplayerprop(userid, "CBasePlayer.m_fFlags", 32.0)
    if duration:
        Temp(userid).add('freeze', duration)
        unfreeze(userid)
        
def unfreeze(userid):
    if not Temp(userid).get('freeze'):
        es.setplayerprop(userid, "CBasePlayer.m_fFlags", 1)
    else:
        Temp(userid).add('freeze', -1)
    gamethread.delayedname(1, 'dndtick', unfreeze, userid)
    
def disguise(userid, duration=None):
    '''Used to make a player appear as the enemy'''
    model = None
    if es.getplayerteam(userid) == 2:
        model = random.choice(['ct_urban','ct_sas','ct_gsg9','ct_gign'])
    else:
        model = random.choice(['t_phoenix','t_leet','t_guerilla','t_arctic'])
    if model:
        playerlib.getPlayer(userid).setModel('models/player/%s'%(userid, model))
        playerlib.getPlayer(userid).setColor(255,255,255)
        #es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)
    if duration:
        Delayed(userid, duration, undisguise, userid)
        
def undisguise(userid):
    '''Used to set a player's model to their teams'''
    if es.exists('userid', userid):
        model = None
        if es.getplayerteam(userid) == 2:
            model = random.choice(['t_phoenix','t_leet','t_guerilla','t_arctic'])
        else:
            model = random.choice(['ct_urban','ct_sas','ct_gsg9','ct_gign'])
        if model:
            playerlib.getPlayer(userid).setModel('models/player/%s'%(userid, model))
            playerlib.getPlayer(userid).setColor(255,255,255)
            
def blind(userid, amount, duration):
    es.server.queuecmd('playerset flash %s %s %s'%(userid, amount, duration))
    
def heal(userid, amount):
    if Temp(userid).get('health') < int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) + int(amount):
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', Temp(userid).get('health'))
    else:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) + int(amount))
    
def regen(userid, delay, amount, loops=None, currentloop=1):
    '''Excutes a looping heal command every X seconds'''
    if es.exists('userid', userid):
        if Player(userid).alive():
            heal(userid, amount)
            if loops:
                if currentloop < loops:
                    currentloop += 1
                    gamethread.delayedname(delay, 'dndtick', regen, (userid, delay, amount, loops, currentloop))
            else:
                gamethread.delayedname(delay, 'dndtick', regen, (userid, delay, amount))
            
def armorregen(userid, delay, amount, loops=None, currentloop=1):
    if es.exists('userid', userid):
        if Player(userid).alive():
            if Temp(userid).get('armor') < int(playerlib.getPlayer(userid).getArmor()) + int(amount):
                playerlib.getPlayer(userid).setArmor(Temp(userid).get('armor'))
            else:
                playerlib.getPlayer(userid).setArmor(int(playerlib.getPlayer(userid).getArmor()) + amount)
            if loops:
                if currentloop < loops:
                    currentloop += 1
                    gamethread.delayedname(delay, 'dndtick', armorregen, (userid, delay, amount, loops, currentloop))
            else:
                gamethread.delayedname(delay, 'dndtick', armorregen, (userid, delay, amount))

def stealth(userid):
    if Player(userid).alive():
        stealth = Temp(userid).get('stealth')
        playerlib.getPlayer(userid).setColor(255,255,255,stealth)        
        handle = es.getplayerhandle(userid)
        color  = 255 + (255 << 8) + (255 << 16)
        color += stealth << 24
        if color >= 2**31: color -= 2**32
        for x in weaponlib.getIndexList('#all'):
            if es.getindexprop(x, 'CBaseEntity.m_hOwnerEntity') == handle:
                es.setindexprop(x, "CBaseEntity.m_nRenderMode", es.getindexprop(x, "CBaseEntity.m_nRenderMode") | 1)
                es.setindexprop(x, "CBaseEntity.m_nRenderFX", es.getindexprop(x, "CBaseEntity.m_nRenderFX") | 256)
                es.setindexprop(x, "CBaseEntity.m_clrRender", color)
        Temp(userid).set('stealthed', 1)
        dndTell(userid, 'You have gone into stealth')
        gamethread.cancelDelayed('stealth_%s'%userid)
    
def unstealth(userid, length=4):
    if Temp(userid).get('stealthed'):
        dndTell(userid, 'You have come out of stealth!')
    Temp(userid).set('stealthed', 0)
    gamethread.cancelDelayed('stealth_%s'%userid)
    gamethread.delayedname(length,'stealth_%s'%userid, stealth, userid)
    playerlib.getPlayer(userid).setColor(255,255,255,255)  
    handle = es.getplayerhandle(userid)    
    color  = 255 + (255 << 8) + (255 << 16)    
    color += 255 << 24
    if color >= 2**31: color -= 2**32
    for x in weaponlib.getIndexList('#all'):
            if es.getindexprop(x, 'CBaseEntity.m_hOwnerEntity') == handle:
                es.setindexprop(x, "CBaseEntity.m_nRenderMode", es.getindexprop(x, "CBaseEntity.m_nRenderMode") | 1)
                es.setindexprop(x, "CBaseEntity.m_nRenderFX", es.getindexprop(x, "CBaseEntity.m_nRenderFX") | 256)
                es.setindexprop(x, "CBaseEntity.m_clrRender", color)
                
def speed(userid, amount, set=None, delay=None):
    '''A command method used to manage user's speed
    There is an issue with using just the playerprop to store the value
    so a dict is used to track each player's speed'''
    if es.exists('userid', userid):
        Temp(userid).add('speed', amount)
        es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", Temp(userid).get('speed'))
        if delay:
            gamethread.delayedname(delay, 'dndtick', speed, (userid, amount*(-1)))
    
def cooldownoff(userid):
    Temp(userid).set('cool down', 0)
    
def save(userid, type, save):
    roll = Temp(userid).get(type) + random.randint(1,20)
    if roll < save:
        return 0
    return 1
            
def damage(userid, attacker, damage, type='physical'):
    '''Used to cause damage between two users
    And is safe to call in player_hurt'''
    health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
    damage_reduced = 0
    #dmg_start = damage
    victim = Temp(userid)
    attacker = Temp(attacker)
    damage = int(damage)
    if type == 'physical':
    
        unstealth(userid)
    
        #victim.get('dodge max damage') = health - 1        
        if victim.get('dodge percent') >= random.randint(1, 100):
            damage_reduced += min(victim.get('dodge max damage'), damage)
            if (health+damage_reduced) > (damage-damage_reduced):
                dndTell(userid.Player, 'You have dodged an attack!')
        
        if victim.get('damage reduction'):
            damage_reduced += min(damage*victim.get('damage reduction'), damage)
            
        if attacker.get('debuff'):
            damage_reduced += min(damage*attacker.get('debuff'), damage)
        
        if damage_reduced > damage:
            pass        
        else:
            damage -= damage_reduced
            if health > damage:
                health -= damage
                es.setplayerprop(victim.Player, 'CBasePlayer.m_iHealth', health)
            else:
                es.server.queuecmd('damage %s %s 32 %s'%(victim.Player, damage, attacker.Player))
    
    if type.lower() in ['magic', 'magical', 'spell']:
    
        '''
        Will be doing saves in dnd/subscripts/spells because of secondary effects
        
        if save:        
            if int(userid.get(save)) + random.randint(1,20) < (int(attacker.getLevel()) / 2 + 1) + (int(attacker.getLevel()) / 4 + 4) + 10:
                pass
        '''
        if victim.get('magic reduction'):
            damage = min(damage, damage * 100 / victim.get('magic reduction'))
        if health > damage:
            health -= damage
            es.setplayerprop(victim.Player, 'CBasePlayer.m_iHealth', health)
        else:
            es.server.queuecmd('damage %s %s 32 %s'%(victim.Player, damage, attacker.Player))
            
            
            
            