import es, dnd, popuplib, spe, cmdlib, random, gamethread, math
from dnd import dnd

def load():
    spe.registerPreHook("player_spawn", pre_spawn)
    spe.registerPreHook("player_hurt", pre_hurt)
    cmdlib.registerClientCommand('!powerattack', powerattack, 'Fighter ability - Chance to do 1.5x damage, chance to miss')
    cmdlib.registerClientCommand('!whirlwind', whirlwind, 'Fighter ability - Deals your damage to all enemies in an AOE')
    
    
    Fighter_Menu = popuplib.create('Fighter Info')
    Fighter_Menu.addline('Fighter Class Information:')
    Fighter_Menu.addline('  !powerattack - Chance to do 1.5x damage, chance to miss')
    Fighter_Menu.addline('      Rifles Only')
    Fighter_Menu.addline('  Level 3: Dual Wield - Chance to do deal damage twice, chance to miss')
    Fighter_Menu.addline('      SMGs Only')
    Fighter_Menu.addline('  Level 5: Weapon Specialization - .8% Damage Per Level (Retroactive)')
    Fighter_Menu.addline('  Level 9: !whirlwind - Your damage is applied to all enemies in an AOE')
    Fighter_Menu.addline('      Last 2 seconds, 15 second cool down')
    Fighter_Menu.addline('  Cleave - after killing an opponent, your last damage dealt is done')
    Fighter_Menu.addline('      in an AOE. (Not yet implemented)')
    Fighter_Menu.addline('-> 9. Main Menu')
    Fighter_Menu.submenu(9, 'main_menu')
    
def unload():
    popuplib.delete('Fighter Info')
    spe.unregisterPreHook("player_spawn", pre_spawn)
    spe.unregisterPreHook("player_hurt", pre_hurt)
    cmdlib.unregisterClientCommand('!whirlwind')
    cmdlib.unregisterClientCommand('!powerattack')
    cmdlib.unregisterClientCommand('!giveLevel')
    
def pre_spawn(ev):
    if dnd.Player(ev['userid']).getClass() == 'Fighter':
        dnd.Temp(ev['userid']).add('Fortitude', dnd.Player(ev['userid']).getLevel()/2+2)
        dnd.Temp(ev['userid']).add('Reflex', dnd.Player(ev['userid']).getLevel()/3)
        dnd.Temp(ev['userid']).add('Will', dnd.Player(ev['userid']).getLevel()/3)
        dnd.Temp(ev['userid']).set('whirlwind', 0)
        dnd.Temp(ev['userid']).set('cool down', 0)
    
    '''
    If you were going to change someones health, you would prehook the spawn event and add it to their health.
    
        dnd.Temp(ev['userid']).add('health', 20)
        
    The reason we hook the event and add it before hand is because we set the health on spawn and change the attributes before
    they actually spawn.
    '''
    
def powerattack(userid, args):
    if dnd.Player(userid).getClass() == 'Fighter':
        if dnd.Temp(userid).get('power attack'):
            dnd.Temp(userid).set('power attack', 0)
            dnd.dndTell(userid, 'Your Power Attack has been disabled')
        else:
            dnd.dndTell(userid, 'Your Power Attack has been enabled')
            dnd.Temp(userid).set('power attack', 1)
            
def whirlwind(userid, args):
    if dnd.Player(userid).getClass() == 'Fighter' and dnd.Player(userid).getLevel() >= 9 and dnd.Player(userid).alive():
        if not dnd.Temp(userid).get('cool down') and not dnd.Temp(userid).get('whirlwind'):
            dnd.dndTell(userid, 'You have activated Whirl Wind!')
            dnd.Temp(userid).set('whirlwind', 1)
            dnd.Temp(userid).set('cool down', 1)
            gamethread.delayedname(2, 'dndtick', whirlwindoff, userid)
            gamethread.delayedname(15, 'dndtick', dnd.cooldownoff, userid)
        else:
            dnd.dndTell(userid, 'Your Whirl Wind is on Cool Down')
            
def whirlwindoff(userid):
    dnd.Temp(userid).set('whirlwind', 0)
    dnd.dndTell(userid, 'Your Whirl Wind is no longer active')
            
def pre_hurt(ev):
    victim = dnd.Player(ev['userid'])
    attacker = dnd.Player(ev['attacker'])
    if attacker.Team != victim.Team and int(ev['attacker']) > 0:
        # Power Attack
        if dnd.Temp(attacker.userid).get('power attack'):
            chance = random.randint(1,100)
            if chance < 35 - attacker.getLevel():
                dnd.dndTell(attacker.userid, 'Your attack missed!')
                dnd.Temp(attacker.userid).set('power attack', 0)
                dnd.heal(victim.userid, ev['dmg_health'])
            if chance > 90 - attacker.getLevel():
                dnd.damage(victim.userid, attacker.userid, int(int(ev['dmg_health']) * .5))
                dnd.dndTell(attacker.userid, 'Your attack did an extra %s damage from Power Attack!'%int(int(ev['dmg_health']) * .5))
                dnd.Temp(attacker.userid).set('power attack', 0)
            if chance >= 35 and chance <= 90:
                dnd.dndTell(attacker.userid, 'Your attack did normal damage')
                dnd.Temp(attacker.userid).set('power attack', 0)
        # Dual Wielding
        if attacker.getClass() == 'Fighter' and attacker.getLevel() >= 3:
            if ev['weapon'] in ['mp5navy', 'tmp', 'mac10', 'p90', 'ump45']:
                chance = random.randint(1,100)
                if chance > 90 - attacker.getLevel():
                    dnd.dndTell(attacker.userid, 'Your off-hand attack hit for %s damage!'%ev['dmg_health'])
                    dnd.damage(victim.userid, attacker.userid, int(ev['dmg_health']))
        # Weapon Specialization
        if attacker.getClass() == 'Fighter' and attacker.getLevel() >= 5:
            #dnd.damage(ev['userid'], ev['attacker'], int(int(ev['dmg_health']) * .8 * attacker.getLevel()))
            pass       
            
def player_hurt(ev):
    if dnd.Temp(ev['attacker']).get('whirlwind'):
        for userid in es.getUseridList():
            if dnd.Player(userid).alive() and es.getplayerteam(userid) != es.getplayerteam(ev['attacker']):
                x,y,z = es.getplayerlocation(userid)
                x1,y1,z1 = es.getplayerlocation(ev['userid'])
                x2,y2,z2 = es.getplayerlocation(ev['attacker'])
                distance = math.sqrt(math.pow((x-x1), 2) + math.pow((y-y1), 2) + math.pow((z-z1), 2))
                distance2 = math.sqrt(math.pow((x2-x1), 2) + math.pow((y2-y1), 2) + math.pow((z2-z1), 2))
                if distance <= 800:
                    if userid != ev['userid']:
                        dnd.damage(userid, ev['attacker'], min(int(ev['dmg_health']), int(ev['dmg_health']) * (600/distance2)))
                        dnd.dndTell(ev['attacker'], 'You dealt %s damage to %s with Whirl Wind!'%(int(min(int(ev['dmg_health']), int(ev['dmg_health']) * (600/distance2))), es.getplayername(userid)))

def giveLevel(userid, args):
    dnd.Player(userid).giveLevel(1)
                